module factor_solve_utilities

use ccpp_kinds, only: r8 => kind_phys 

! This code was generated by Preprocessor revision 005a579d4f5af97c55e894b0c610a291b2f403ca
! Preprocessor source https://github.com/NCAR/MechanismToCode

! This code is generated from tag 255 of the mechanism, Chapman.  It is named Chapman_vdemo
! This tag was created on 2019-01-18 14:11:16.02075-07 by ajc and is marked as not buggy

  implicit none

  integer, parameter :: number_sparse_factor_elements = 16

  public :: factor, solve 

  contains


subroutine backsolve_L_y_eq_b(LU,b,y)


  real(r8), intent(in) :: LU(:)
  real(r8), intent(in) :: b(:)
  real(r8), intent(out) :: y(:)


  y(1) = b(1)
  y(2) = b(2)
  y(2) = y(2) - LU(2) * y(1)
  y(3) = b(3)
  y(3) = y(3) - LU(3) * y(1)
  y(3) = y(3) - LU(5) * y(2)
  y(4) = b(4)
  y(4) = y(4) - LU(7) * y(3)
  y(5) = b(5)
  y(5) = y(5) - LU(8) * y(3)
  y(5) = y(5) - LU(12) * y(4)


end subroutine backsolve_L_y_eq_b



subroutine backsolve_U_x_eq_y(LU,y,x)


  real(r8), intent(in) :: LU(:)
  real(r8), intent(in) :: y(:)
  real(r8), intent(out) :: x(:)
  real(r8) :: temporary


  temporary = y(5)
  x(5) = LU(16) * temporary
  temporary = y(4)
  temporary = temporary - LU(15) * x(5)
  x(4) = LU(11) * temporary
  temporary = y(3)
  temporary = temporary - LU(10) * x(4)
  temporary = temporary - LU(14) * x(5)
  x(3) = LU(6) * temporary
  temporary = y(2)
  temporary = temporary - LU(9) * x(4)
  temporary = temporary - LU(13) * x(5)
  x(2) = LU(4) * temporary
  temporary = y(1)
  x(1) = LU(1) * temporary


end subroutine backsolve_U_x_eq_y

subroutine factor(LU)


  real(r8), intent(inout) :: LU(:)


  LU(1) = 1./LU(1)
  LU(2) = LU(2) * LU(1)
  LU(3) = LU(3) * LU(1)
  LU(4) = 1./LU(4)
  LU(5) = LU(5) * LU(4)
  LU(10) = LU(10) - LU(5)*LU(9)
  LU(14) = LU(14) - LU(5)*LU(13)
  LU(6) = 1./LU(6)
  LU(7) = LU(7) * LU(6)
  LU(8) = LU(8) * LU(6)
  LU(11) = LU(11) - LU(7)*LU(10)
  LU(12) = LU(12) - LU(8)*LU(10)
  LU(15) = LU(15) - LU(7)*LU(14)
  LU(16) = LU(16) - LU(8)*LU(14)
  LU(11) = 1./LU(11)
  LU(12) = LU(12) * LU(11)
  LU(16) = LU(16) - LU(12)*LU(15)
  LU(16) = 1./LU(16)


end subroutine factor

subroutine solve(LU, x, b) 

  real(r8), intent(in) :: LU(:), b(:) ! solve LU * x = b 
  real(r8), intent(out) :: x(:) 
  real(r8) :: y(size(b)) 

  call backsolve_L_y_eq_b(LU, b, y)
  call backsolve_U_x_eq_y(LU, y, x)

end subroutine solve 


end module factor_solve_utilities
