module kinetics_utilities
use ccpp_kinds, only: r8 => kind_phys

! This code was generated by Preprocessor revision 005a579d4f5af97c55e894b0c610a291b2f403ca
! Preprocessor source https://github.com/NCAR/MechanismToCode

! This code is generated from tag 255 of the mechanism, Chapman.  It is named Chapman_vdemo
! This tag was created on 2019-01-18 14:11:16.02075-07 by ajc and is marked as not buggy

  use factor_solve_utilities, only:  factor 

  implicit none

  public :: dforce_dy_times_vector, factored_alpha_minus_jac, p_force, dforce_dy, kinetics_init, kinetics_final 
  contains



subroutine dforce_dy(LU, rate_constant, number_density, number_density_air)

  ! Compute the derivative of the Forcing w.r.t. each chemical
  ! Also known as the Jacobian
  real(r8), intent(out) :: LU(:)
  real(r8), intent(in) :: rate_constant(:)
  real(r8), intent(in) :: number_density(:)
  real(r8), intent(in) :: number_density_air

  LU(:) = 0


  ! df_O/d(N2)
    !  k_N2_O1D_1: N2 + O1D -> 1*O + 1*N2
    LU(3) = LU(3) + rate_constant(1) * number_density(2)


  ! df_O1D/d(N2)
    !  k_N2_O1D_1: N2 + O1D -> 1*O + 1*N2
    LU(2) = LU(2) - rate_constant(1) * number_density(2)


  ! df_O/d(O)
    !  k_O_O3_1: O + O3 -> 2*O2
    LU(6) = LU(6) - rate_constant(3) * number_density(5)

    !  k_O_O2_M_1: M, O + O2 -> 1*O3
    LU(6) = LU(6) - rate_constant(4) * number_density(4) * number_density_air


  ! df_O2/d(O)
    !  k_O_O3_1: O + O3 -> 2*O2
    LU(7) = LU(7) + 2*rate_constant(3) * number_density(5)

    !  k_O_O2_M_1: M, O + O2 -> 1*O3
    LU(7) = LU(7) - rate_constant(4) * number_density(4) * number_density_air


  ! df_O3/d(O)
    !  k_O_O3_1: O + O3 -> 2*O2
    LU(8) = LU(8) - rate_constant(3) * number_density(5)

    !  k_O_O2_M_1: M, O + O2 -> 1*O3
    LU(8) = LU(8) + rate_constant(4) * number_density(4) * number_density_air


  ! df_O/d(O1D)
    !  k_N2_O1D_1: N2 + O1D -> 1*O + 1*N2
    LU(5) = LU(5) + rate_constant(1) * number_density(1)

    !  k_O1D_O2_1: O1D + O2 -> 1*O + 1*O2
    LU(5) = LU(5) + rate_constant(2) * number_density(4)


  ! df_O1D/d(O1D)
    !  k_N2_O1D_1: N2 + O1D -> 1*O + 1*N2
    LU(4) = LU(4) - rate_constant(1) * number_density(1)

    !  k_O1D_O2_1: O1D + O2 -> 1*O + 1*O2
    LU(4) = LU(4) - rate_constant(2) * number_density(4)


  ! df_O/d(O2)
    !  k_O1D_O2_1: O1D + O2 -> 1*O + 1*O2
    LU(10) = LU(10) + rate_constant(2) * number_density(2)

    !  k_O_O2_M_1: M, O + O2 -> 1*O3
    LU(10) = LU(10) - rate_constant(4) * number_density(3) * number_density_air

    !  j_O2_1: O2 -> 2*O
    LU(10) = LU(10) + 2*rate_constant(5)


  ! df_O1D/d(O2)
    !  k_O1D_O2_1: O1D + O2 -> 1*O + 1*O2
    LU(9) = LU(9) - rate_constant(2) * number_density(2)


  ! df_O2/d(O2)
    !  k_O_O2_M_1: M, O + O2 -> 1*O3
    LU(11) = LU(11) - rate_constant(4) * number_density(3) * number_density_air

    !  j_O2_1: O2 -> 2*O
    LU(11) = LU(11) - rate_constant(5)


  ! df_O3/d(O2)
    !  k_O_O2_M_1: M, O + O2 -> 1*O3
    LU(12) = LU(12) + rate_constant(4) * number_density(3) * number_density_air


  ! df_O/d(O3)
    !  k_O_O3_1: O + O3 -> 2*O2
    LU(14) = LU(14) - rate_constant(3) * number_density(3)

    !  j_O3_2: O3 -> 1*O + 1*O2
    LU(14) = LU(14) + rate_constant(7)


  ! df_O1D/d(O3)
    !  j_O3_1: O3 -> 1*O1D + 1*O2
    LU(13) = LU(13) + rate_constant(6)


  ! df_O2/d(O3)
    !  k_O_O3_1: O + O3 -> 2*O2
    LU(15) = LU(15) + 2*rate_constant(3) * number_density(3)

    !  j_O3_1: O3 -> 1*O1D + 1*O2
    LU(15) = LU(15) + rate_constant(6)

    !  j_O3_2: O3 -> 1*O + 1*O2
    LU(15) = LU(15) + rate_constant(7)


  ! df_O3/d(O3)
    !  k_O_O3_1: O + O3 -> 2*O2
    LU(16) = LU(16) - rate_constant(3) * number_density(3)

    !  j_O3_1: O3 -> 1*O1D + 1*O2
    LU(16) = LU(16) - rate_constant(6)

    !  j_O3_2: O3 -> 1*O + 1*O2
    LU(16) = LU(16) - rate_constant(7)

end subroutine dforce_dy

subroutine kinetics_init(vmr, number_density, number_density_air)

 real(r8), intent(in) :: vmr(:)
 real(r8), intent(out):: number_density(5)
 real(r8), intent(in) :: number_density_air


 number_density(1) = vmr(1) * number_density_air ! N2
 number_density(3) = vmr(2) * number_density_air ! O1D
 number_density(2) = vmr(3) * number_density_air ! O
 number_density(4) = vmr(4) * number_density_air ! O2
 number_density(5) = vmr(5) * number_density_air ! O3

end subroutine kinetics_init


subroutine kinetics_final(vmr, number_density, number_density_air)

 real(r8), intent(out) :: vmr(:)
 real(r8), intent(in) :: number_density(5)
 real(r8), intent(in) :: number_density_air


 vmr(1) = number_density(1) / number_density_air ! N2
 vmr(2) = number_density(3) / number_density_air ! O1D
 vmr(3) = number_density(2) / number_density_air ! O
 vmr(4) = number_density(4) / number_density_air ! O2
 vmr(5) = number_density(5) / number_density_air ! O3

end subroutine kinetics_final


subroutine factored_alpha_minus_jac(LU, alpha, dforce_dy)
  !compute LU decomposition of [alpha * I - dforce_dy]

  real(r8), intent(in) :: dforce_dy(:)
  real(r8), intent(in) :: alpha
  real(r8), intent(out) :: LU(:)

  LU(:) = -dforce_dy(:)

! add alpha to diagonal elements

  LU(1) = -dforce_dy(1) + alpha 
  LU(4) = -dforce_dy(4) + alpha 
  LU(6) = -dforce_dy(6) + alpha 
  LU(11) = -dforce_dy(11) + alpha 
  LU(16) = -dforce_dy(16) + alpha 

  call factor(LU) 

end subroutine factored_alpha_minus_jac

subroutine p_force(rate_constant, number_density, number_density_air, force)
  ! Compute force function for all molecules

  real(r8), intent(in) :: rate_constant(:)
  real(r8), intent(in) :: number_density(:)
  real(r8), intent(in) :: number_density_air
  real(r8), intent(out) :: force(:)



! N2
  force(1) = 0


! O1D
  force(2) = 0

  ! k_N2_O1D_1: N2 + O1D -> 1*O + 1*N2
  force(2) = force(2) - rate_constant(1) * number_density(1) * number_density(2)

  ! k_O1D_O2_1: O1D + O2 -> 1*O + 1*O2
  force(2) = force(2) - rate_constant(2) * number_density(2) * number_density(4)

  ! j_O3_1: O3 -> 1*O1D + 1*O2
  force(2) = force(2) + rate_constant(6) * number_density(5)


! O
  force(3) = 0

  ! k_N2_O1D_1: N2 + O1D -> 1*O + 1*N2
  force(3) = force(3) + rate_constant(1) * number_density(1) * number_density(2)

  ! k_O1D_O2_1: O1D + O2 -> 1*O + 1*O2
  force(3) = force(3) + rate_constant(2) * number_density(2) * number_density(4)

  ! k_O_O3_1: O + O3 -> 2*O2
  force(3) = force(3) - rate_constant(3) * number_density(3) * number_density(5)

  ! k_O_O2_M_1: M, O + O2 -> 1*O3
  force(3) = force(3) - rate_constant(4) * number_density(3) * number_density(4) * number_density_air

  ! j_O2_1: O2 -> 2*O
  force(3) = force(3) + 2*rate_constant(5) * number_density(4)

  ! j_O3_2: O3 -> 1*O + 1*O2
  force(3) = force(3) + rate_constant(7) * number_density(5)


! O2
  force(4) = 0

  ! k_O_O3_1: O + O3 -> 2*O2
  force(4) = force(4) + 2*rate_constant(3) * number_density(3) * number_density(5)

  ! k_O_O2_M_1: M, O + O2 -> 1*O3
  force(4) = force(4) - rate_constant(4) * number_density(3) * number_density(4) * number_density_air

  ! j_O2_1: O2 -> 2*O
  force(4) = force(4) - rate_constant(5) * number_density(4)

  ! j_O3_1: O3 -> 1*O1D + 1*O2
  force(4) = force(4) + rate_constant(6) * number_density(5)

  ! j_O3_2: O3 -> 1*O + 1*O2
  force(4) = force(4) + rate_constant(7) * number_density(5)


! O3
  force(5) = 0

  ! k_O_O3_1: O + O3 -> 2*O2
  force(5) = force(5) - rate_constant(3) * number_density(3) * number_density(5)

  ! k_O_O2_M_1: M, O + O2 -> 1*O3
  force(5) = force(5) + rate_constant(4) * number_density(3) * number_density(4) * number_density_air

  ! j_O3_1: O3 -> 1*O1D + 1*O2
  force(5) = force(5) - rate_constant(6) * number_density(5)

  ! j_O3_2: O3 -> 1*O + 1*O2
  force(5) = force(5) - rate_constant(7) * number_density(5)

end subroutine p_force

pure subroutine dforce_dy_times_vector(dforce_dy, vector, cummulative_product)

  !  Compute product of [ dforce_dy * vector ]
  !  Commonly used to compute time-truncation errors [dforce_dy * force ]

  real(r8), intent(in) :: dforce_dy(:) ! Jacobian of forcing
  real(r8), intent(in) :: vector(:)    ! Vector ordered as the order of number density in dy
  real(r8), intent(out) :: cummulative_product(:)  ! Product of jacobian with vector

  cummulative_product(:) = 0


  ! df_O/d(N2) * N2_temporary
  cummulative_product(3) = cummulative_product(3) + dforce_dy(3) * vector(1)


  ! df_O1D/d(N2) * N2_temporary
  cummulative_product(2) = cummulative_product(2) + dforce_dy(2) * vector(1)


  ! df_O/d(O) * O_temporary
  cummulative_product(3) = cummulative_product(3) + dforce_dy(6) * vector(3)


  ! df_O2/d(O) * O_temporary
  cummulative_product(4) = cummulative_product(4) + dforce_dy(7) * vector(3)


  ! df_O3/d(O) * O_temporary
  cummulative_product(5) = cummulative_product(5) + dforce_dy(8) * vector(3)


  ! df_O/d(O1D) * O1D_temporary
  cummulative_product(3) = cummulative_product(3) + dforce_dy(5) * vector(2)


  ! df_O1D/d(O1D) * O1D_temporary
  cummulative_product(2) = cummulative_product(2) + dforce_dy(4) * vector(2)


  ! df_O/d(O2) * O2_temporary
  cummulative_product(3) = cummulative_product(3) + dforce_dy(10) * vector(4)


  ! df_O1D/d(O2) * O2_temporary
  cummulative_product(2) = cummulative_product(2) + dforce_dy(9) * vector(4)


  ! df_O2/d(O2) * O2_temporary
  cummulative_product(4) = cummulative_product(4) + dforce_dy(11) * vector(4)


  ! df_O3/d(O2) * O2_temporary
  cummulative_product(5) = cummulative_product(5) + dforce_dy(12) * vector(4)


  ! df_O/d(O3) * O3_temporary
  cummulative_product(3) = cummulative_product(3) + dforce_dy(14) * vector(5)


  ! df_O1D/d(O3) * O3_temporary
  cummulative_product(2) = cummulative_product(2) + dforce_dy(13) * vector(5)


  ! df_O2/d(O3) * O3_temporary
  cummulative_product(4) = cummulative_product(4) + dforce_dy(15) * vector(5)


  ! df_O3/d(O3) * O3_temporary
  cummulative_product(5) = cummulative_product(5) + dforce_dy(16) * vector(5)


end subroutine dforce_dy_times_vector

end module kinetics_utilities
