module rate_constants_utility 

use ccpp_kinds, only: r8 => kind_phys 

! This code was generated by Preprocessor revision 005a579d4f5af97c55e894b0c610a291b2f403ca
! Preprocessor source https://github.com/NCAR/MechanismToCode

! This code is generated from tag 255 of the mechanism, Chapman.  It is named Chapman_vdemo
! This tag was created on 2019-01-18 14:11:16.02075-07 by ajc and is marked as not buggy

  implicit none

  public :: p_rate_mapping,  k_rate_constant 

  contains

subroutine p_rate_mapping(tuv_rates, j_rate_const)
    real(KIND=r8),           intent(in)  :: tuv_rates(:) ! /sec 
    real(KIND=r8),           intent(out) :: j_rate_const(:) ! /sec 
    j_rate_const(1) = tuv_rates(1) 
    j_rate_const(2) = tuv_rates(2) 
    j_rate_const(3) = tuv_rates(3) 
end subroutine p_rate_mapping 

subroutine k_rate_constant(k_rate_constants, TEMP)
    real(KIND=r8),           intent(in)  :: TEMP ! temperature
    real(KIND=r8),           intent(out) :: k_rate_constants(:) ! rate constant for the each reaction
    k_rate_constants(1) =  2.150000e-11_r8 * exp(110.00_r8 / TEMP)  
    k_rate_constants(2) =  3.300000e-11_r8 * exp(55.00_r8 / TEMP)  
    k_rate_constants(3) =  8.000000e-12_r8 * exp(-2060.00_r8 / TEMP)  
    k_rate_constants(4) = usr_O_O2( temp ) 
end subroutine k_rate_constant 



REAL(KIND=r8) FUNCTION usr_O_O2( temp )
! for cesm-consistent reaction labels
! O+O2+M -> O3+M

    REAL(KIND=r8), INTENT(IN) :: temp

    usr_O_O2 = 6.00e-34_r8*(temp/300._r8)**(-2.4_r8)

END FUNCTION usr_O_O2


end module rate_constants_utility
